#include<stdio.h>
#include<stdlib.h>

#define BUFSIZE 4096
static char *fn="./b";
static char *fnout="./out";
static char buf[BUFSIZE+1];

FILE *f, *fout;
static int total=0;
static int good=0;
static int clusternum=0;
struct {
  int itemnum;  /* the number of items in Ci */
  int mismatch; /* the number of mismatch items in Ci */
} quality[1000];

static int cluster;
void report(int c, int p, int e)
{

  if (c < 1000) {
    quality[c].itemnum = p + e;
    if (p < e)
      quality[c].mismatch = p;
    else
      quality[c].mismatch = e;
  } else
    printf("The cluster number is out of the array upper limit.\n");
    
  printf("Cluster %3d: p(%4d) e(%4d)", c+1, p, e);
  if (e!=0 && p!=0) printf("  !!!!\n");
  else printf("\n");
  total += p + e;
  clusternum++;
  if (p < e)  good += e;
  else  good += p;
}

int main(int argc, char *argv[])
{
  int i, cluster, oldcluster, sum_p, sum_e, dummy;
  char class;

  if (argc>=2) {
    fn=argv[1];
  }  
  f = fopen(fn, "r");

  if (f==NULL) {
    fprintf(stderr, "Error opening file!\n");
    exit(1);
  }
   
  i=1;
  fscanf(f, "%d %c %d", &dummy, &class, &cluster);
  while (!feof(f)) {
    sum_p=0; sum_e=0; oldcluster=cluster;
    while(!feof(f)) {
      if (class=='p') sum_p++; 
      else {
        if (class!='e') fprintf(stderr, "Bad class: %c\n", class); 
        sum_e++;
      }
      fscanf(f, "%d %c %d", &dummy, &class, &cluster);
      if (feof(f) || oldcluster!=cluster) {
        report(oldcluster, sum_p, sum_e);
        break;
      }
    }
  }

  printf("Total: %d\n", total);
  /*fprintf(stderr, "good=%d,  clusternum=%d\n",good, clusternum);
    fprintf(stderr, "Quality: %f\n",((float)good / total) / clusternum);
    fprintf(stderr, "Wrong: %f\n\n\n",((float)(total-good)/total)/clusternum); */
  fprintf(stderr,"%d\t%d\t%f\t%f\n", good, clusternum,
	  ((float)good / total) / clusternum, 
          ((float)(total-good)/total)/clusternum);
  fclose(f);

  return(0);
}
